﻿import ImageLoader ;


/*
Notes :
expected instance names within carouselMc :
info_mc
previous_btn
next_btn
loader_mc
bg_mc

*/

class Carousel
{
	private var tc:String = "Carousel | ";
	
	private var carouselMc:MovieClip ;
	private var imageHolderMc:MovieClip;
	private var infoMc:MovieClip;
	private var bwdMc:MovieClip;
	private var fwdMc:MovieClip;
	private var loaderMc:MovieClip;
	private var bgMc:MovieClip;
	
	private var slideArray:Array;
	private var loadedSlideIndexArray:Array;
	
	private var currentSlideIndex:Number;
	private var transitionFrameRate:Number;
	
	private var currentSlideMc:MovieClip;
	private var previousSlideMc:MovieClip;
	
	
	
	
	public function Carousel( mc:MovieClip, slideArray:Array )
	{
		this.carouselMc = mc ;
		this.slideArray = slideArray ;
		
		activateKeys() ;
		init() ;
	}
	
	
	public function init():Void
	{
		this.imageHolderMc = this.carouselMc.imageHolder_mc ;
		this.infoMc = this.carouselMc.info_mc ;
		this.bwdMc = this.carouselMc.previous_btn ;
		this.fwdMc = this.carouselMc.next_btn ;
		this.loaderMc = this.carouselMc.loader_mc ;
		this.bgMc = this.carouselMc.bg_mc ;
		
		this.loadedSlideIndexArray = new Array() ;
		
		this.transitionFrameRate = 5;
		
		makeNav() ;
		hideInfo() ;
	}
	
	
	
	
	
	
	
	
	
	
	private function makeNav():Void
	{
		var tthis = this ;

		this.bwdMc.onRelease = function()
		{
			tthis.bwd() ;
		}
		
		this.fwdMc.onRelease = function()
		{
			tthis.fwd() ;
		}
		
		
		this.imageHolderMc.useHandCursor = false ;
		this.imageHolderMc.onRollOver = function()
		{
			tthis.showInfo();
		}
		this.imageHolderMc.onRollOut = function()
		{
			tthis.hideInfo();
		}
		this.imageHolderMc.onRelease = function()
		{
			tthis.hide() ;
		}
		
		
		this.bgMc.useHandCursor = false ;
		this.bgMc.onPress = function()
		{
			tthis.hide() ;
		}
	}
	
	
	
	
	
	public function fwd():Void
	{
		if ( this.currentSlideIndex >= this.slideArray.length-1 )
		{
			changeSlide( 0 );
		}else{
			changeSlide( this.currentSlideIndex + 1 ) ;
		}
	}
	public function bwd():Void
	{
		if ( this.currentSlideIndex == 0 )
		{
			changeSlide( this.slideArray.length - 1 ) ;
		}else{
			changeSlide( this.currentSlideIndex - 1 ) ;
		}
	}
	
	
	
	
	public function showInfo():Void
	{
		var info:String = this.slideArray[ this.currentSlideIndex ].info ;
		if( info != undefined )
		{
			this.infoMc.info_txt.htmlText = info ;
			Toolbox.getInstance().alphaFade( this.infoMc, 100, this.transitionFrameRate, mx.transitions.easing.None.easeIn ) ;
		}
	}
	public function hideInfo():Void
	{
		Toolbox.getInstance().alphaFade( this.infoMc, 0, this.transitionFrameRate, mx.transitions.easing.None.easeIn ) ;
	}
	
	
	
	
	
		
	public function emptyCarousel():Void
	{
		var i:Number = this.loadedSlideIndexArray.length ;
		while( i-- )
		{
			this.imageHolderMc[ "image"+ this.loadedSlideIndexArray[ i ] ].removeMovieClip() ;
		}
	}
	
	
	
	
	
	
	
	public function changeSlide( index:Number ):Void
	{
		if( this.carouselMc.cover_mc == undefined )
		{
			trace( tc+"changeSlide() | info = "+ this.slideArray[ index ].info ) ;
			trace( tc+"changeSlide() | src = "+ this.slideArray[ index ].src ) ;
			
			this.currentSlideIndex = index ;
			
			// hide previous
			this.previousSlideMc._visible = false;
			Toolbox.getInstance().cover( this.carouselMc, true ) ;
			show() ;
			
			var iLength:Number = this.loadedSlideIndexArray.length ;
			for( var i=0; i<iLength; i++ )
			{
				if( this.loadedSlideIndexArray[ i ] == this.currentSlideIndex )
				{
					var indexIsLoaded = true ;
					break ;
				}
			}
			if( indexIsLoaded )
			{
				displaySlide() ;
			}else{
				loadImage() ;
			}
		}
	}
	
	
	private function loadImage():Void
	{
		var tthis = this;
		
		this.loaderMc.gotoAndStop( 1 ) ;
		Toolbox.getInstance().alphaFade( this.loaderMc, 100, this.transitionFrameRate, mx.transitions.easing.None.easeIn ) ;
		
		var mcName = "image" + this.currentSlideIndex ;
		var imagePath = this.slideArray[ this.currentSlideIndex ].src ;
		var mc = this.imageHolderMc.createEmptyMovieClip( mcName, this.imageHolderMc.getNextHighestDepth() ) ;
		
		mc.onLoadImage = function ()
		{
			tthis.displaySlide() ;
			tthis.loaderMc._alpha = 0 ;
		}
		mc.onLoadImageError = function ( errorCode:String )
		{
			trace( "errorCode = "+ errorCode ) ;
			
			var errorTxt = this.createTextField( "error_txt", 1, 0, 0, 300, 100 ) ;
			var erroFormat:TextFormat = new TextFormat() ;
			erroFormat.color = 0xFF0000 ;
			erroFormat.align = "center" ;
			errorTxt.text = "ERROR : "+ errorCode ;
			errorTxt.setTextFormat( erroFormat ) ;
			
			this.onLoadImage() ;
		}
		new ImageLoader( mc, imagePath, 0, 0, this.loaderMc ) ;
		
		this.loadedSlideIndexArray.push( this.currentSlideIndex ) ;
	}
	
	
	
	private function displaySlide():Void
	{
		var tthis = this ;
		
		this.currentSlideMc = this.imageHolderMc[ "image"+ this.currentSlideIndex ] ;
		
		// position
		currentSlideMc._x = -( currentSlideMc._width / 2 ) ;
		currentSlideMc._y = -( currentSlideMc._height / 2 ) ;
		
		// hide previous
		this.previousSlideMc._visible = false;
		this.previousSlideMc = this.currentSlideMc ;
		
		// show current
		this.currentSlideMc._visible = true;
		this.currentSlideMc._alpha = 0;
		Toolbox.getInstance().alphaFade( this.currentSlideMc, 100, this.transitionFrameRate, mx.transitions.easing.None.easeIn ) ;
		
		this.currentSlideMc.onAlphaFade = function()
		{
			Toolbox.getInstance().cover( tthis.carouselMc, false );
		}
		
	}
	
	
	

	
	
	private function activateKeys():Void
	{
		var tthis = this;
		var keyListener = new Object();
		
		keyListener.onKeyUp = function()
		{
			switch( Key.getCode() )
			{
				case 37 : tthis.bwd() ; break ; // up
				case 38 : tthis.fwd() ; break ; // left
				case 39 : tthis.fwd() ; break ; // right
				case 40 : tthis.bwd() ; break ; // down
			}
		}
		
		Key.addListener( keyListener );
	}
	
	
	
	public function hide():Void
	{
		if( this.bgMc != undefined )
		{
			this.carouselMc._visible = false ;
		}
	}
	public function show():Void
	{
		this.carouselMc._visible = true ;
	}
	
}