﻿import Carousel ;
import Lightbox ;

class SiteManager
{
	private var tc:String = "SiteManager | ";
	private static var instance:SiteManager;
	
	private var lightboxObj:Lightbox ;
	private var carouselObj:Carousel ;
	
	private var currentSectionMc:MovieClip ;
	
	private var currentSlideArray:Array ;
	
	
	// CONSTRUCTOR
	
	public static function getInstance( mc:MovieClip ):SiteManager
	{
		if( instance == null )
		{
			instance = new SiteManager( mc ) ;
		}
		return instance;
	}
	
	private function SiteManager()
	{
	}
	
	
	
	// SITE METHODS
	
	public function setCurrentSection( mc:MovieClip, slideArray:Array ):Void
	{
		trace( tc+"setCurrentSection ( "+ mc +", "+ slideArray.length +" )" ) ;
		
		this.currentSectionMc = mc ;
		this.currentSlideArray = slideArray ;
	}
	
	
	
	// LIGHTBOX METHODS
	
	public function makeLightbox( mc:MovieClip ):Void
	{
		trace( tc+"makeLightbox ( "+ mc +" )" ) ;
		
		delete  this.lightboxObj ;
		this.lightboxObj = new Lightbox( mc, this.currentSlideArray ) ; 
	}
	
	
	
	// CAROUSEL METHODS
	
	public function makeCarousel( mc:MovieClip ):Void
	{
		this.carouselObj.emptyCarousel() ;
		delete  this.carouselObj ;
		this.carouselObj = new Carousel( mc, this.currentSlideArray ) ;
	}
	
	public function showCarousel( slideArrayIndex:Number ):Void
	{
		trace( tc+"showCarousel ( "+ slideArrayIndex +" )" ) ;
		
		this.carouselObj.changeSlide( slideArrayIndex ) ;
	}
	
	public function hideCarousel( mc:MovieClip ):Void
	{
		trace( tc+"hideCarousel ( "+ mc +" )" ) ;
		
		mc._visible = false ;
	}
	
}